/*

Copyright Yann OLLIVIER 1998-2000
(yann.ollivier@clipper.ens.fr)

This software may be freely distributed as is, if including
this whole notice.

There is absolutely no restriction regarding the HTML documents produced by
running this software.

The software may be modified, but any modification should include this
whole notice as is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fstream>

using std::ifstream;

long compteur=0,compteurimg=1;
FILE*texfile,*tablefile,*indexfile,*destftex;
char *htmHead,*htmFoot,*texHead,*texFoot,*nom,*texfnom,*rc,*table;//*indexfnom
char IndReuse,IndTex,verbose;//char IndIndex;
long rang;

//#define HYPERTEX_DEBUG

//#define FR
//#define EN

#ifdef FR
  #include"htxstdfr.h"
  #define HTMLHEAD "htmlhead.f"
  #define HTMLFOOT "htmlfoot.f"
  //#define INDEX "index.f"
  char *suff=".html.fr";
#else
  #include"htxstden.h"
  #ifdef EN
	  #define HTMLHEAD "htmlhead.e"
	  #define HTMLFOOT "htmlfoot.e"
    char *suff=".html.en";
  #else
	  #define HTMLHEAD "htmlhead"
	  #define HTMLFOOT "htmlfoot"
    char *suff=".html";
  #endif
  //#define INDEX "index.e"
#endif

char * MidStr(char *s,int i1,int i2)
{if(i1<0)i1=0;
 char *s1=new char[i2-i1+2];int i;
 for(i=i1;i<=i2&&s[i];i++)s1[i-i1]=s[i];
 s1[i-i1]=0;return s1;
}

char * CopyStr(char *s)
{ char *s1=new char [strlen(s)+1];char *s12=s1,*s2=s;
 while((*s12++=*s2++));return s1;}

 /*void Ecris(char *src,char *&dest)
	 {long int n=strlen(src)+1;
	 delete dest;dest=new char [n];
	 for(long int i=0;i<n;i++)dest[i]=src[i];
	 }
	*/
char * InsStr(char *s,long n,char *t)
{long l=strlen(s);
 if(n<0||n>l)return s;
 long i,p=strlen(t);
 char *s1=new char [l+p+1];
 for(i=0;i<n;)s1[i]=s[i++];
 for(i=n;i<n+p;i++)s1[i]=t[i-n];
 for(i=n+p;i<l+p;i++)s1[i]=s[i-p];
 s1[l+p]=0;
 return s1;
}

char EqStr(char *s,char *s2)
{while(*s&&*s2&&*s==*s2){s++;s2++;}
 return(!(*s2||*s));
}

char CompStr(char *s,char *s2)  //regarde si str2 apparait en position n dans str
{while(*s&&*s2&&*s==*s2){s++;s2++;}
 return(!*s2);
}

char * DelStr(char *s,long n,long p)  //Efface p caracteres de s a partir de la position n
{long q=strlen(s),i;
 if(n+p>q)return CopyStr(s);
 char *s1=new char [q-p+1];
 for(i=0;i<n;i++)s1[i]=s[i];
 for(i=n;i<q-p;i++)s1[i]=s[i+p];
 s1[q-p]=0;return s1;
}

long OrderStr(char *s1,char *s2)
{long i;
 for(i=0;s1[i]&&s2[i]&&s1[i]==s2[i];i++);
 if(s1[i]==s2[i])return 0;else if(s1[i]<s2[i])return i+1; else return -i-1;
}

/*char * Substitute(char *s,char *s1,char *s2)
	{long n=strlen(s),p=strlen(s1),q=strlen(s2),pos;
	char *r=new char [n+1+q];  //-p
	r[0]=0;
	for(pos=0;pos<n;)if(CompStr(s+pos,s1)){
 	sprintf(r+strlen(r),"%s",s2);
	pos+=p;
 	}else{
	sprintf(r+strlen(r),"%c",s[pos]);
	pos++;
 	}
	return r;
	}
 */

long Substitute(char *&s,long pos,long n,char *t)
{long p=strlen(s),q=strlen(t),i;
 if(pos+n>p)return -1;
 char *s2=new char [p+1+q-n];
 for(i=0;i<pos;i++)s2[i]=s[i];
 for(i=pos;i<pos+q;i++)s2[i]=t[i-pos];
 for(i=pos+q;i<p+q-n;i++)s2[i]=s[i+n-q];
 s2[p+q-n]=0;
 delete s;s=s2;
 return p+q-n;
}

long FindNext(char *s,char *t)
{long n=strlen(s),pos=0;
 for(;pos<n;pos++)if(CompStr(s+pos,t))return pos;
 return -1;
}

/*
	char * SubstituteAll(char *s,char *s1,char *s2)
	{long n=strlen(s),p=strlen(s1),q=strlen(s2),pos,num;
	if(!p)return CopyStr(s);
	for(pos=0,num=0;pos<n;)if(CompStr(s+pos,s1)){
	pos+=p;num++;
	}else pos++;
	char *r=new char [n+1+num*(q-p)];
	r[0]=0;
	for(pos=0;pos<n;)if(CompStr(s+pos,s1)){
	sprintf(r+strlen(r),"%s",s2);
 	pos+=p;
 	}else{
	sprintf(r+strlen(r),"%c",s[pos]);
	pos++;
 	}
	return r;
	}
 */

char *FileToStr(FILE*f)
{fseek(f,0,0);
 long n=0;char s=1;
 while(s&&!feof(f)){
 	 fread(&s,sizeof(char),1,f);n++;
 };
 char *str=new char [n];
 fseek(f,0,0);
 fread(str,sizeof(char),n-1,f);str[n-1]=0;
 return str;
}

long SearchNextBracket(char *s)
{long i;
 for(i=0;s[i];i++)if(s[i]=='{')return i;else if(s[i]=='\\')i++;
 return -1;
}

long SearchCorOpenBracket(char *s)  //cherche l'accolade fermante a une accolade ouvrante
{if(!*s)return -1;
 long i,c=1;
 for(i=1;s[i];i++){
	 if(s[i]=='{')c++;else if(s[i]=='}')c--;
	 if(!c)return i;
	 if(s[i]=='\\')i++;
 };
 return -1;
}

struct TCommande{
	char *nom,*corps;int nargs,niv;
	TCommande(){nargs=0;niv=0;nom=new char [1];nom[0]=0;corps=new char[1];corps[0]=0;};
	~TCommande(){delete[]nom;delete[]corps;};
	long Setup(char*);
	long Expand(char*src,char*&dest);
};

typedef TCommande * PTCommande;

PTCommande *Commandes;long nCommandes;

/*
struct TLien{
	TLien(){
		nom=new char [1];nom[0]=0;nom2=NULL;
		fnum=-1;type=-1;pos=-1;destfnum=-1;posfin=-1;
	}
	char type,*nom,*nom2;
	//0:pointer vers fichier numero destfnum
	//1:pointer vers fichier au nom de *nom;
	//2:\maketitle
	//3:\makeprevtitle
	//4:\makeparenttitle
	//5:\makenexttitle
	//6:\ifnext
	//7:\tonext
	//8:\makemeta

 	//n:pointer vers index reference *nom
	long fnum,pos,destfnum,posfin;
};

typedef TLien * PTLien;

PTLien *IndexList;long NumLiens=0;
PTLien *IndexLList;long NumLiens2=0;

void AjouteIndex(char *nomp,long fnump,long nump)
{
		PTLien *IndexList2=new PTLien [NumLiens+1];
		long i;
		for(i=0;i<NumLiens&&OrderStr(IndexList[i]->nom,nomp)>=0;i++)
		IndexList2[i]=IndexList[i];
		IndexList2[i]=new TLien(nomp,fnump,nump);
		for(;i<NumLiens;i++)IndexList2[i+1]=IndexList[i];
		if(NumLiens)delete IndexList;
		IndexList=IndexList2;
		NumLiens++;
}*/

long Extrais(char *src,char *&dest)  //IDEM, place le texte intermediaire dans dest
{long fin=SearchCorOpenBracket(src);
 if(fin!=-1){
 	 delete dest;dest=new char [fin];
 	 for(long i=0;i<fin-1;i++)dest[i]=src[i+1];
 	 dest[fin-1]=0;
 };
 return fin;
}

char* ExtraisNom(char*src,char*&dest)
{long i,j,n;
 for(i=0;src[i]&&src[i]!='\"';i++);
 if(!src[i])return NULL;
 for(n=i+1;src[n]&&src[n]!='\"';n++);
 if(!src[n])return NULL;
 char*ret=new char[n-i];
 for(j=i+1;j<n;j++)ret[j-i-1]=src[j];
 ret[n-i-1]=0;
 delete dest;
 for(i=n+1;src[i]&&src[i]!='>';i++);
 if(!src[i])return NULL;
 for(n=i+1;src[n]&&src[n]!='<';n++);
 if(!src[n])return NULL;
 dest=new char[n-i];
 for(j=i+1;j<n;j++)dest[j-i-1]=src[j];
 dest[n-i-1]=0;
 return ret;
}

long IsBeginMathTeX(char*s,long n)
{
 if(s[n]=='$')return (s[n+1]=='$'?2:1);
 if(s[n]!='\\')return 0;
 if(CompStr(s+n,"\\begin{equation*}"))return 17;
 if(CompStr(s+n,"\\begin{eqnarray*}"))return 17;
 if(CompStr(s+n,"\\["))return 2;
 if(CompStr(s+n,"\\begin{equation}"))return 16;
 if(CompStr(s+n,"\\begin{eqnarray}"))return 16;
 if(CompStr(s+n,"\\("))return 2;
 if(CompStr(s+n,"\\texcommand")){
	 long longmatch=0,i;
	 for(i=0;i<nCommandes;i++)if(CompStr(s+n,Commandes[i]->nom)){longmatch=strlen(Commandes[i]->nom);break;}
	 if(longmatch>10)return 0;
	 return 10;
 }
  if(CompStr(s+n,"\\tex")){
	 long longmatch=0,i;
	 for(i=0;i<nCommandes;i++)if(CompStr(s+n,Commandes[i]->nom)){longmatch=strlen(Commandes[i]->nom);break;}
	 if(longmatch>4)return 0;
	 return 4;
 }
 return 0;
}

long IsEndMathTeX(char*s,long n)
{
 if(s[n]=='$')return (s[n+1]=='$'?2:1);
 if(s[n]!='\\')return 0;
 if(CompStr(s+n,"\\end{equation*}"))return 15;
 if(CompStr(s+n,"\\end{eqnarray*}"))return 15;
 if(CompStr(s+n,"\\]"))return 2;
 if(CompStr(s+n,"\\end{equation}"))return 14;
 if(CompStr(s+n,"\\end{eqnarray}"))return 14;
 if(CompStr(s+n,"\\)"))return 2;
 return 0;
}

long NextBeginMathTeX(char*s,long n)
{
 int p;
 for(p=n;s[p];p++){
	 if(IsBeginMathTeX(s,p))return p;
	 if(s[p]=='\\')p++;
 }
 return -1;
}

long NextEndMathTeX(char*s,long n)
{
 int p;
 for(p=n;s[p];p++){
	 if(IsEndMathTeX(s,p))return p;
	 if(s[p]=='\\')p++;
 }
 return -1;
}

char* TronqueNom(char *s)
{long n;
 for(n=0;!EqStr(s+n,suff);n++);
 char*s2=new char[n+1];
 long i=0;
 for(;i<n;i++)s2[i]=s[i];
 s2[n]=0;
 return s2;
}

void EcrisTable(char *s)
{
 char*table2=InsStr(table,strlen(table),s);
 delete[]table;table=table2;
}

/*void EcrisIndex(char *s)
{
 if(IndIndex)fwrite(s,sizeof(char),strlen(s),indexfile);
}*/

/*void Affiche(char *s)
	{char s2[1]="";gets(s2);
	long i=0;
	while(s[i]){
	printf("%c",s[i]);
	if(i%1000==999)gets(s2);
	i++;
	}
	printf("\n\n");
	gets(s2);
	} */

long TCommande::Setup(char*def)
{
 char*temps;long n,pos;
 temps=new char[1];temps[0]=0;
 // if(!CompStr(def,"\\def"))return;
 pos=4+SearchNextBracket(def+4);
 pos+=Extrais(def+pos,temps);
 if(temps[0]=='\\')nom=CopyStr(temps);else nom=InsStr(temps,0,"\\");
 if(verbose)printf("Adding command %s\n",nom);
 pos+=SearchNextBracket(def+pos);
 n=pos+Extrais(def+pos,temps);
 corps=temps;
 nargs=0; //Number of times the (unique) argument is used
 for(pos=0;corps[pos];pos++){
	 if(corps[pos]=='#')nargs++;
	 if(corps[pos]=='\\')pos++;
 }
 return n;
}

long TCommande::Expand(char*src,char*&dest)
{
 long pos,l;l=nargs*(strlen(src)-1);
 if(dest!=NULL)delete[]dest;
 if(!nargs){dest=CopyStr(corps);return strlen(corps);}
 dest=new char[strlen(corps)+l+1];
 dest[0]=0;
 char*dest2=dest;
 for(pos=0;corps[pos];){
	 if(corps[pos]=='\\'){
		 dest2+=sprintf(dest2,"\\%c",corps[pos+1]);
		 pos+=2;
	 }else if(corps[pos]=='#'){
		 dest2+=sprintf(dest2,"%s",src);
		 pos++;
	 }else
		 sprintf(dest2++,"%c",corps[pos++]);
 }
 return dest2-dest;
}

long AjouteCommande(char*src)
{
 PTCommande *Commandes2=new PTCommande [nCommandes+1];
 PTCommande pcomm;
 pcomm=new TCommande;long n=pcomm->Setup(src);
 long i;long l=strlen(pcomm->nom);
 for(i=0;i<nCommandes&&strlen(Commandes[i]->nom)>l;i++)
	 Commandes2[i]=Commandes[i];
 Commandes2[i]=pcomm;
 for(;i<nCommandes;i++)Commandes2[i+1]=Commandes[i];
 if(nCommandes)delete[] Commandes;
 Commandes=Commandes2;
 nCommandes++;
 return n;
}

long nfiles;

struct TFile{
	long numero;
	char*name,*meta,*title;
	long nextfnum,prevfnum,parentfnum;
	TFile(){name=CopyStr("");title=CopyStr("");meta=CopyStr("");
		nextfnum=-1;prevfnum=-1;parentfnum=-1;};
};

typedef TFile * PTFile;

PTFile * FilesList;

void AjouteFile()
{
 PTFile *FilesList2=new PTFile [nfiles+1];
 PTFile pfile=new TFile;
 long i;
 for(i=0;i<nfiles;i++)FilesList2[i]=FilesList[i];
 FilesList2[i]=pfile;
 if(nfiles)delete[]FilesList;
 FilesList=FilesList2;
 nfiles++;
}

struct TTableItem{
	long numero;
	long rank;
	char*ref;
};

typedef TTableItem * PTTableItem;

PTTableItem * TableList;long nTableList;

void AjouteTableItem(long numero,long rank,char*ref=NULL)
{
 PTTableItem *TableList2=new PTTableItem [nTableList+1];
 PTTableItem pitem=new TTableItem;
 pitem->numero=numero;pitem->rank=rank;if(ref==NULL)pitem->ref=NULL;else pitem->ref=CopyStr(ref);
 long i;
 for(i=0;i<nTableList;i++)TableList2[i]=TableList[i];
 TableList2[i]=pitem;
 if(nTableList)delete[]TableList;
 TableList=TableList2;
 nTableList++;
}

char IsSimpleText(char*s)
{
 long i=IsBeginMathTeX(s,0);
 while(s[i]>='a'&&s[i]<='z'||s[i]>='A'&&s[i]<='Z')i++;
 return (s[i]==0||IsEndMathTeX(s,i)?1:0);
}

long AjouteImage(char *src,FILE*destf)
{
 long l,f,p=0;char *temps=new char [1];temps[0]=0;
 if(CompStr(src,"\\texcommand")){
	 p=SearchNextBracket(src);if(p==-1)return -1;
	 p+=Extrais(src+p,temps);
	 l=1;
 }else if(CompStr(src,"\\tex")){
	 p=SearchNextBracket(src);if(p==-1)return -1;
	 p+=Extrais(src+p,temps);
	 l=1;
 }else if(CompStr(src,"\\includegraphics")){
	 p=SearchNextBracket(src);if(p==-1)return -1;
	 p+=SearchCorOpenBracket(src+p);
	 delete[]temps;temps=MidStr(src,0,p);
	 l=1;
 }else{
	 p=NextEndMathTeX(src,IsBeginMathTeX(src,0));if(p==-1)return -1;
	 l=IsEndMathTeX(src,p);
	 delete[]temps;temps=MidStr(src,0,p+l-1);
	 if(destf!=NULL&&IsSimpleText(temps)){
		 temps[strlen(temps)-l]=0;
		 	fprintf(destf,"<I>%s</I>",temps+IsBeginMathTeX(temps,0));
			return p+l;
	 }
 }
 if(destf==NULL)return p+l;
 if(IndTex){
	 if((temps[0]=='$'&&temps[1]!='$')||CompStr(temps,"\\(")||
			 (CompStr(src,"\\tex")&&!CompStr(src,"\\texcommand"))){
		 if(!IndReuse)fprintf(destftex,"\\newpage\n\\hspace{\\tempslightneg}\\rule[.5ex]{1mm}{.5pt} %s\n\n",temps);
#ifdef NOPNG
		 fprintf(destf,"<IMG SRC=\"%s%.3li.gif\" class=\"hyperteximg\" ALT=\"%s\">",FilesList[0]->name,compteurimg++,temps);
#else
		 fprintf(destf,"<IMG SRC=\"%s%.3li.png\" class=\"hyperteximg\" ALT=\"%s\">",FilesList[0]->name,compteurimg++,temps);
#endif
	 }else if(CompStr(src,"\\texcommand")){
		 if(!IndReuse)fprintf(destftex,"\n%s\n",temps);
	 }else{
		 if(!IndReuse)fprintf(destftex,"\\newpage\n\\hspace{\\tempslightneg}\\rule[.5ex]{1mm}{.3pt}\\parbox[c]{\\textwidth}{%s}\n\n",temps);
#ifdef NOPNG
		 fprintf(destf,"<P ALIGN=CENTER><IMG SRC=\"%s%.3li.gif\" class=\"hyperteximg\" ALT=\"%s\"></P>",FilesList[0]->name,compteurimg++,temps);
#else
		 fprintf(destf,"<P ALIGN=CENTER><IMG SRC=\"%s%.3li.png\" class=\"hyperteximg\" ALT=\"%s\"></P>",FilesList[0]->name,compteurimg++,temps);
#endif
	 }
 }else{
	 fprintf(destf,"%s",temps);
 }
 return p+l;
}

void InitTeX(char*name)
{
 char*name2=new char[strlen(name)+18];
 sprintf(name2,"%s.temp.images.tex",name);
 destftex=fopen(name2,"wb");
 fprintf(destftex,"%s\n\n\\pagestyle{empty}\n"
		 "\\setlength{\\parindent}{0mm}\n"
		 "\\newlength{\\tempslightneg}\n"
		 "\\setlength{\\tempslightneg}{-1mm}\n"
		 "\\addtolength{\\tempslightneg}{-1em}\n"
		 "\n\n",texHead);
 compteurimg=1;
 delete[]name2;
}

void Traiteppm(char*name,char*bname)
{
 char*instr=new char[500+20*strlen(name)+strlen(bname)];
 sprintf(instr,
		 "i=`basename %s .ppm`;"
		 "NAME=%s;"
		 "test -f $i.gif && /bin/rm -f $i.png ; "
		 "test -f $i.ppm && /bin/rm -f $i.ppm ; "
		 "echo \"image $i\" ; "
		 "(echo \"($i) run\" ; echo \"quit\") |"
		 "gs -q -dNOPAUSE -DNOPROMPT "
		 "-sDEVICE=ppmraw -sOutputFile=${NAME}.temp.ppm -dTextAlphaBits=4 "
		 "-dGraphicsAlphaBits=4 -r648x648 -dEPSCrop;"
		 "pnmcrop ${NAME}.temp.ppm > $i.ppm ; "
		 "/bin/rm ${NAME}.temp.ppm ; "
		 "/bin/rm $i ; "
		 ,name,bname);
 system(instr);
 ifstream f(name);
 char s[10]="";
 f.getline(s,9);
 int w,h;
 f>>w;f>>h;f.getline(s,9);
 f.getline(s,9);
 int x,y,xmin=3*w,xmax,ymin;int c;
 for(y=0;y<h;y++){
	 for(x=0;x<3*w;x++){
		 c=f.get();
		 if(c!=255&&x<=xmin){
			 xmin=x;ymin=y;
			 for(x++;c!=255&&x<3*w;x++)c=f.get();
			 xmax=--x;
		 }
	 }
 }
 f.close();
 sprintf(instr,"pnmcut %i %i %i %i %s|pnmcrop", xmax/3,0,w-xmax/3,h,name);
 if(ymin&&ymin<h/2)sprintf(instr+strlen(instr),"|pnmpad -white -l1 -r1 -t%i",h-2*ymin-1);
 else if(2*ymin==h)sprintf(instr+strlen(instr),"|pnmpad -white -l1 -r1 -b%i",2*ymin-h+1);
 else if(ymin>h/2)sprintf(instr+strlen(instr),"|pnmpad -white -l1 -r1 -b%i",2*ymin-h+1);
#ifdef NOPNG
 sprintf(instr+strlen(instr),"|ppmtogif -transparent \\#ffffff > `basename %s .ppm`.gif ;/bin/rm %s;",name,name);
#else
 sprintf(instr+strlen(instr),"> tmp1.%s;"
		 "convert tmp1.%s -negate tmp1.%s.neg.png;"
		 "convert tmp1.%s -gamma 0.01 tmp1.%s.neg.png +matte -compose Copy_Opacity -composite `basename %s .ppm`.png;"
		 "rm tmp1.%s.neg.png tmp1.%s %s;",name,name,name,name,name,name,name,name,name);
#endif
 system(instr);
 delete[]instr;
}

void FinishTeX(char*name)
{
 char*name2=new char[strlen(name)+18];
 sprintf(name2,"%s.temp.images.tex",name);
 fprintf(destftex,"%s",texFoot);
 fclose(destftex);
 if(compteurimg>1&&!IndReuse){
	 char*imgstex2gif=new char[300+strlen(name)];
	 sprintf(imgstex2gif,
			 "NAME=%s.temp.images;"
			 "latex ${NAME}.tex ; "
			 "dvips -S 1 -i ${NAME}.dvi -o `basename ${NAME} .temp.images` -E; "
#ifndef HYPERTEX_DEBUG
			 "rm ${NAME}.tex ${NAME}.dvi ${NAME}.toc ${NAME}.log ${NAME}.aux ;"
#endif
//			 "NAME=`basename ${NAME} .temp.images` ;"
			 "echo \"Converting images to ppm\" ;"
			 ,name);
	 system(imgstex2gif);
	 delete[]imgstex2gif;
	 int i;
	 for(i=1;i<compteurimg;i++){
		 sprintf(name2,"%s%.3i.ppm",name,i);
		 Traiteppm(name2,name);
	 }
 }else{
	 char*temps2=new char[strlen(name2)+4];
	 sprintf(temps2,"rm %s",name2);
	 system(temps2);
	 delete[]temps2;
 }
 delete[]name2;
}


long ScanNewFile(char*,long,long=-1,long=-1);

long ScanString(char*src,long numero,long tablerank)
{
 long pos=0,n;long i,longmatch;
 char *temps=CopyStr(""),*temps2=CopyStr("");
 FILE*includef;
 while(1){
   if(!src[pos])break;
   if(src[pos]=='\\'){
		 longmatch=0;
 		 for(i=0;i<nCommandes;i++)
			 if(CompStr(src+pos,Commandes[i]->nom)){longmatch=strlen(Commandes[i]->nom)-1;break;};
     if(CompStr(src+pos+1,"page")&&longmatch<=4){
       n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
       pos+=n;
       n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
       pos+=n+1;
       n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
       pos+=n;
       n=Extrais(src+pos,temps);
       ScanNewFile(temps,tablerank+1,numero);
			 pos+=n+1;
		 }else if(CompStr(src+pos+1,"name")&&longmatch<=4){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 FilesList[numero]->name=CopyStr(temps);
			 pos+=n+1;
		 }else if(CompStr(src+pos+1,"title")&&longmatch<=5){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 FilesList[numero]->title=CopyStr(temps);
			 pos+=n+1;
 		 }else if(CompStr(src+pos+1,"meta")&&longmatch<=4){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 FilesList[numero]->meta=CopyStr(temps);
			 pos+=n+1;
		 }else if(CompStr(src+pos+1,"include")&&longmatch<=7&&!CompStr(src+pos+1,"includegraphics")){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 pos+=n+1;
			 includef=fopen(temps,"rb");
			 if(includef==NULL)
				 printf("File %s not found.\n",temps);
			 else{
				 delete[]temps;temps=FileToStr(includef);fclose(includef);
				 numero=ScanString(temps,numero,tablerank);
			 }
		 }else if(CompStr(src+pos+1,"newpage")&&longmatch<=7){
			 ScanString(htmFoot,numero,tablerank);
			 if(verbose)printf("File %li scanned.\n",numero);
			 numero=ScanNewFile(src+pos+8,tablerank,FilesList[numero]->parentfnum,numero);
			 break;
		 }else if(CompStr(src+pos+1,"def")&&longmatch<=3){
			 pos+=AjouteCommande(src+pos)+1;
		 }else if(CompStr(src+pos+1,"tableentry")&&longmatch<=10){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 pos+=n+1;
			 AjouteTableItem(numero,tablerank+1,temps);
		 }else if(IsBeginMathTeX(src,pos)||CompStr(src+pos+1,"includegraphics")&&longmatch<=15){
			 n=AjouteImage(src+pos,NULL);if(n==-1)goto FinErreur;
			 pos+=n;
		 }else if(longmatch){
			 if(Commandes[i]->nargs){
				 pos+=longmatch+1;
				 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n;
				 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 }else{
				 n=strlen(Commandes[i]->nom)-1;
			 }
			 Commandes[i]->Expand(temps,temps2);
			 numero=ScanString(temps2,numero,tablerank);
			 pos+=n+1;
		 }else if(src[pos+1]=='\\'||src[pos+1]=='$'){
			 pos+=2;
		 }else pos++;
	 }else if(src[pos]=='$'){
		 if(IsBeginMathTeX(src,pos)){
			 n=AjouteImage(src+pos,NULL);if(n==-1)goto FinErreur;
			 pos+=n;
		 }else pos++;
	 }else pos++;
 }
 delete[]temps;delete[]temps2;
 return numero;

FinErreur:
 printf("Error in the %li th file.\n",numero);
 printf("%s\n",src+pos);
 return numero;
}


long ScanNewFile(char*src,long tablerank,long parentfnum,long prevfnum)
{
 long numero=nfiles;
 AjouteFile();AjouteTableItem(numero,tablerank);
 FilesList[numero]->numero=numero;
 FilesList[numero]->parentfnum=parentfnum;FilesList[numero]->prevfnum=prevfnum;
 if(prevfnum!=-1)FilesList[prevfnum]->nextfnum=numero;
 ScanString(htmHead,numero,tablerank);
 long numero2=ScanString(src,numero,tablerank);
 if(numero==numero2){
	 ScanString(htmFoot,numero,tablerank);
	 if(verbose)printf("File %li scanned.\n",numero);
 }
 return numero2;
}

long ChercheNom(char*nom)
{
  long i;
  for(i=0;i<nfiles;i++)if(EqStr(FilesList[i]->name,nom))return i;
  return -1;
}


#define UpdatePos(l) {{if(dernposto!=-1)dernposto+=l;if(dernposif!=-1)dernposif+=l;}}

char TraiteNewFile(char*,long* =NULL);
char TraiteEndFile(long,FILE*);

char Traite(char *src,long& numero,FILE*destf)
{
 long dernposto,dernposif;
 FILE*includef;
 long pos=0,n,n2;dernposto=-1;dernposif=-1;
 char *temps=CopyStr("");char*temps2=CopyStr("");
 long l,i=-1,longmatch;
 while(1){
	 if(!src[pos])break;
	 if(pos==dernposto){
		 fprintf(destf,"</A>");
		 pos++;dernposto=-1;
	 }else if(pos==dernposif){
		 pos++;dernposif=-1;
	 }else if(src[pos]=='\\'){
		 longmatch=0;
		 for(i=0;i<nCommandes;i++)
			 if(CompStr(src+pos,Commandes[i]->nom)){longmatch=strlen(Commandes[i]->nom)-1;break;};
		 if(CompStr(src+pos+1,"page")&&longmatch<=4){
			 if(pos<=dernposto)goto FinErreur;
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 fprintf(destf,"<A NAME=\"%li\" HREF=\"%s%s\">",compteur,FilesList[compteur]->name,suff);
			 Traite(temps,numero,destf);
			 pos+=n+1;
			 fprintf(destf,"</A>");
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 pos+=n+1;
			 TraiteNewFile(temps);//Wrong file count if new pages in the link text
		 }else if(CompStr(src+pos+1,"name")&&longmatch<=4){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n+1;
		 }else if(CompStr(src+pos+1,"title")&&longmatch<=5){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n+1;
		 }else if(CompStr(src+pos+1,"meta")&&longmatch<=4){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n+1;
/*		 }else if(CompStr(src+pos+1,"tex")&&longmatch<=3){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 fprintf(destf,"%s",temps);
			 pos+=n+1;*/
		 }else if(CompStr(src+pos+1,"include")&&longmatch<=7&&!CompStr(src+pos+1,"includegraphics")){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 includef=fopen(temps,"rb");if(includef==NULL){
				 printf("File %s not found.\n",temps);
			 }else{
				 delete[]temps;temps=FileToStr(includef);
				 fclose(includef);
				 if(!Traite(temps,numero,destf))goto FinErreur;
			 }
			 pos+=n+1;
		 }else if(CompStr(src+pos+1,"shell")&&longmatch<=5){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 delete[]temps2;temps2=new char[strlen(temps)+50];
			 sprintf(temps2,"%s>> temp.hypertex.shell;",temps);
			 system(temps2);includef=fopen("temp.hypertex.shell","rb");
			 if(includef==NULL){
				 printf("Error while executing %s\n",temps);
			 }else{
				 delete[]temps;temps=FileToStr(includef);
				 if(strlen(temps)&&temps[strlen(temps)-1]=='\n')temps[strlen(temps)-1]=0;
				 fclose(includef);system("/bin/rm temp.hypertex.shell");
				 if(!Traite(temps,numero,destf))goto FinErreur;
			 }
			 pos+=n+1;

		 }else if(CompStr(src+pos+1,"topage")&&longmatch<=6){
			 if(pos<=dernposto)goto FinErreur;
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
			 dernposto=pos+n;pos++;
			 fprintf(destf,"<A HREF=\"%s%s\">",temps,suff);
		 }else if(CompStr(src+pos+1,"toparent")&&longmatch<=8){
			 if(pos<=dernposto)goto FinErreur;
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 if(FilesList[numero]->parentfnum!=-1){
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 dernposto=pos+n;pos++;
				 fprintf(destf,"<A HREF=\"%s%s#%li\">",FilesList[FilesList[numero]->parentfnum]->name,suff,numero);
			 }else{
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n+1;
			 };
		 }else if(CompStr(src+pos+1,"ifnoparent")&&longmatch<=10){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 if(FilesList[numero]->parentfnum==-1){
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 dernposif=pos+n;pos++;
			 }else{
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n+1;
			 };
		 }else if(CompStr(src+pos+1,"ifparent")&&longmatch<=8){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 if(FilesList[numero]->parentfnum!=-1){
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 dernposif=pos+n;pos++;
			 }else{
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n+1;
			 };
		 }else if(CompStr(src+pos+1,"toprev")&&longmatch<=6){
			 if(pos<=dernposto)goto FinErreur;
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 if(FilesList[numero]->prevfnum!=-1){
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 dernposto=pos+n;pos++;
				 fprintf(destf,"<A HREF=\"%s%s\">",FilesList[FilesList[numero]->prevfnum]->name,suff);
			 }else{
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n+1;
			 };
		 }else if(CompStr(src+pos+1,"ifnoprev")&&longmatch<=8){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 if(FilesList[numero]->prevfnum==-1){
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 dernposif=pos+n;pos++;
			 }else{
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n+1;
			 };
		 }else if(CompStr(src+pos+1,"ifprev")&&longmatch<=6){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 if(FilesList[numero]->prevfnum!=-1){
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 dernposif=pos+n;pos++;
			 }else{
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n+1;
			 };
		 }else if(CompStr(src+pos+1,"tonext")&&longmatch<=6){
			 if(pos<=dernposto)goto FinErreur;
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 if(FilesList[numero]->nextfnum!=-1){
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 dernposto=pos+n;pos++;
				 fprintf(destf,"<A HREF=\"%s%s\">",FilesList[FilesList[numero]->nextfnum]->name,suff);
			 }else{
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n+1;
			 }
		 }else if(CompStr(src+pos+1,"ifnonext")&&longmatch<=8){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 if(FilesList[numero]->nextfnum!=-1){
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 dernposif=pos+n;pos++;
			 }else{
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n+1;
			 }
		 }else if(CompStr(src+pos+1,"ifnext")&&longmatch<=6){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 if(FilesList[numero]->nextfnum!=-1){
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 dernposif=pos+n;pos++;
			 }else{
				 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n+1;
			 };
		 }else if(CompStr(src+pos+1,"maketitle")&&longmatch<=9){
			 fprintf(destf,"%s",FilesList[numero]->title);
			 pos+=10;
		 }else if(CompStr(src+pos+1,"makenexttitle")&&longmatch<=13&&FilesList[numero]->nextfnum!=-1){
			 fprintf(destf,"%s",FilesList[FilesList[numero]->nextfnum]->title);
			 pos+=14;
		 }else if(CompStr(src+pos+1,"makeprevtitle")&&longmatch<=13&&FilesList[numero]->prevfnum!=-1){
			 fprintf(destf,"%s",FilesList[FilesList[numero]->prevfnum]->title);
			 pos+=14;
		 }else if(CompStr(src+pos+1,"makeparenttitle")&&longmatch<=15&&FilesList[numero]->parentfnum!=-1){
			 fprintf(destf,"%s",FilesList[FilesList[numero]->parentfnum]->title);
			 pos+=16;
		 }else if(CompStr(src+pos+1,"newpage")&&longmatch<=7){
			 if(!TraiteEndFile(numero,destf))goto FinErreur;
			 TraiteNewFile(src+pos+8,&numero);
			 break;
		 }else if(CompStr(src+pos+1,"makemeta")&&longmatch<=8){
			 fprintf(destf,"%s",FilesList[numero]->meta);
			 pos+=9;
		 }else if(CompStr(src+pos+1,"tableentry")&&longmatch<=10){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
			 pos+=n+1;
			 fprintf(destf,"<A NAME=\"%s\"></A>",temps);
		 }else if(CompStr(src+pos+1,"table")&&longmatch<=5){
			 fprintf(destf,"%s",table);
			 pos+=6;
		 }else if(CompStr(src+pos+1,"totable")&&longmatch<7){ //Obsolete
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n+1;

 			 /*      }else
							 if(CompStr(src+pos+1,"toindex")&&!CompStr(src+pos+1,"toindexitem")){
	 						 if(pos<=dernposto)goto FinErreur;
	 						 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
	 						 pos+=n;
	 						 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
	 						 dernposto=pos+n;pos++;
	 						 fprintf(destf,"<A HREF=\"%s\">",indexfnom);
	 						 }else if(CompStr(src+pos+1,"indexitem")){
	 						 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
	 						 pos+=n;
	 						 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
	 						 fprintf(destf,"<A
							 NAME=\"#Index%li\"></A>",NumLiens);
							 AjouteIndex(temps,cfnom,NumLiens);
							 pos+=n+1;
							 }else if(CompStr(src+pos+1,"toindexitem")){
							 if(pos<=dernposto)goto FinErreur;
							 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
							 pos+=n;
							 n=Extrais(src+pos,temps);if(n==-1)goto FinErreur;
							 fprintf(destf,"<A HREF=\"");
							 AjouteLien(temps,cfnom,strlen(dests));
							 fprintf(destf,"\">");
							 pos+=n;
							 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
							 pos+=n;
							 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;     
							 dernposto=pos+n;pos++;
				*/

		 }else if(CompStr(src+pos+1,"def")&&longmatch<=3){
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n+1;
			 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n;
			 n=SearchCorOpenBracket(src+pos);if(n==-1)goto FinErreur;
			 pos+=n+1;
		 }else if(CompStr(src+pos+1,"date")&&longmatch<=4){
			 delete temps;temps=date();
			 fprintf(destf,"%s",temps);
			 pos+=5;
		 }else if(IsBeginMathTeX(src,pos)||CompStr(src+pos+1,"includegraphics")&&longmatch<=15){
			 n=AjouteImage(src+pos,destf);
			 if(n==-1)goto FinErreur;
			 pos+=n;
		 }else if(longmatch){
			 if(Commandes[i]->nargs){
				 pos+=longmatch+1;
				 n=SearchNextBracket(src+pos);if(n==-1)goto FinErreur;
				 pos+=n;
				 n=Extrais(src+pos,temps);if(n2==-1)goto FinErreur;
				 pos+=n+1;
			 }else{
				 pos+=strlen(Commandes[i]->nom);
			 }
			 Commandes[i]->Expand(temps,temps2);
			 if(!Traite(temps2,numero,destf))goto FinErreur;
		 }else if(CompStr(src+pos+1,"\\")){
			 fprintf(destf,"\\");
			 pos+=2;
		 }else if(CompStr(src+pos+1,"$")){
			 fprintf(destf,"$");
			 pos+=2;
		 }else if(CompStr(src+pos+1,"{")){
			 fprintf(destf,"{");
			 pos+=2;
		 }else if(CompStr(src+pos+1,"}")){
			 fprintf(destf,"}");
			 pos+=2;
		 }else if(CompStr(src+pos+1,"%")){
			 fprintf(destf,"%%");
			 pos+=2;
		 }else if(src[pos+1]=='~'){
			 fprintf(destf,"~");
			 pos+=2;
		 }else{
			 fprintf(destf,"%c",src[pos+1]);
			 pos+=2;
		 }
	 }else if(src[pos]=='$'){
		 if(IsBeginMathTeX(src,pos)){
			 n=AjouteImage(src+pos,destf);if(n==-1)goto FinErreur;
			 pos+=n;
		 }else fprintf(destf,"$");
	 }else if(src[pos]=='\n'&&src[pos+1]=='\n'){
		 fprintf(destf,"\n<P>\n");
		 pos+=2;
	 }else if(src[pos]=='~'){
		 if(pos&&src[pos-1]=='/')fprintf(destf,"~");else fprintf(destf,"&nbsp;");//hack to depart TeX non-breakable space from www..../~login URLs
		 pos++;
#ifdef FR
	 }else if(TypoFr(src+pos)){
		 fprintf(destf,"&nbsp;%c",src[pos+1]);pos+=2;
#endif
	 }else{
		 fprintf(destf,"%c",src[pos]);
		 pos++;
	 }
 }
FinNormale:
 delete[] temps;delete[]temps2;
 return 1;

FinErreur:
 delete[] temps;delete[]temps2;
 return 0;
}

char TraiteNewFile(char*src,long*numerop)
{
 long numero=compteur;char Ind=1;compteur++;
 if(verbose)printf("Generating file %li\n",numero);
 char *cfnom=new char[strlen(FilesList[numero]->name)+strlen(suff)+1];
 sprintf(cfnom,"%s%s",FilesList[numero]->name,suff);
 FILE*destf;
 destf=fopen(cfnom,"wb");
 if(destf==NULL){
	 printf("No writing possible in %s\n.",cfnom);
	 return 0;
 }
 long numero2=numero;
 Ind&=Traite(htmHead,numero,destf);
 if(numero2!=numero){printf("htmlhead file contains some \\newpage command. Processing impossible.\n");return 0;}
 Ind&=Traite(src,numero,destf);
 if(numerop!=NULL)*numerop=numero;
 if(numero==numero2)return Ind&=TraiteEndFile(numero,destf);else return Ind;
}

char TraiteEndFile(long numero,FILE*destf)
{
 char Ind=1;
 Ind&=Traite(htmFoot,numero,destf);
 fclose(destf);
 if(Ind){
	 printf("File %s%s, entitled \"%s\" successfully generated.\n",FilesList[numero]->name,suff,FilesList[numero]->title);
	 return 1;
 }else{
	 printf("\nError in file %s (\"%s\")\n",FilesList[numero]->name,FilesList[numero]->title);
	 return 0;
 }
}

void GenereTable()
{
 long i,j,crank=0;
 if(FilesList[0]->nextfnum==-1){
	 TableList++;nTableList--;
	 for(i=0;i<nTableList;i++)TableList[i]->rank--;
 }
 EcrisTable("<UL>\n");
 for(i=0;i<nTableList;i++){
	 if(!strlen(FilesList[TableList[i]->numero]->title))continue;
	 while(TableList[i]->rank>crank){
		 j=0;while(j++<crank)EcrisTable("  ");
		 crank++;
		 EcrisTable(" <UL>\n");
	 }
	 while(TableList[i]->rank<crank){
		 crank--;
		 j=0;while(j++<crank)EcrisTable("  ");
		 EcrisTable(" </UL>\n");
	 }
	 j=0;while(j++<crank)EcrisTable("  ");
	 EcrisTable("<LI><A HREF=\"");
	 EcrisTable(FilesList[TableList[i]->numero]->name);
	 EcrisTable(suff);
	 if(TableList[i]->ref==NULL){
		 EcrisTable("\">");
		 EcrisTable(FilesList[TableList[i]->numero]->title);
	 }else{
		 EcrisTable("#");
		 EcrisTable(TableList[i]->ref);
		 EcrisTable("\">");
		 EcrisTable(TableList[i]->ref);
	 }
	 EcrisTable("</A>\n");
 }
 while(crank){
	 crank--;
	 j=0;while(j++<crank)EcrisTable("  ");
	 EcrisTable(" </UL>\n");
 }
 EcrisTable("</UL>\n");
}

/*void GenereIndex()
{
		if(IndIndex){
 		long i;char *temps=new char [1];temps[0]=0;
		for(i=0;i<NumLiens;i++){
		delete temps;temps=new char [strlen(IndexList[i]->nom)+strlen(IndexList[i]->fnom)+40];
		sprintf(temps,"<A HREF=\"%s#Index%li\">%s</A><BR>\n",IndexList[i]->fnom,IndexList[i]->num,IndexList[i]->nom);
		EcrisIndex(temps);
 		}
		delete temps;
		}
}

long IndexLien(char *s)
{
		if(IndIndex){
 		long i;
		for(i=0;i<NumLiens;i++)if(EqStr(IndexList[i]->nom,s))return i;
		}
		return -1;
}

void InsereIndexLiens()
{
		if(IndIndex){
 		long i,j;FILE*f;char *s,*s2,*t;
		for(i=NumLiens2-1;i>=0;i--){
		f=fopen(IndexLList[i]->fnom,"rb");
		s=FileToStr(f);fclose(f);
		j=IndexLien(IndexLList[i]->nom);
		if(j==-1){
		t=new char [strlen(nom)+12];
		sprintf(t,"%sindex.htm",nom);
		printf("Dans le fichier %s, rfrence  l'lment d'index \"%s\", inexistant.",IndexLList[i]->fnom,IndexLList[i]->nom);
		}else{
		t=new char [strlen(IndexList[j]->fnom)+20];
		sprintf(t,"%s#Index%li",IndexList[j]->fnom,IndexList[j]->num);
		}
		s2=InsStr(s,IndexLList[i]->num,t);
		delete t;delete s;
		f=fopen(IndexLList[i]->fnom,"wb");
		fseek(f,0,0);
		fwrite(s2,sizeof(char),strlen(s2),f);
		fclose(f);
		delete s2;
		}
		}
}*/

long ExtraisPath(char *s)
{long n=strlen(s),i;
 for(i=n-1;i>=0&&s[i]!='/';i--);
 return i;
}

int main(int narg,char ** varg)
{

 long i;FILE*f;
 if(narg<2||CompStr(varg[1],"-h")||CompStr(varg[1],"-help")){
	 printf("Usage:\n"
			 "hypertex [-reuse] [-notex] [-verbose] [-suffix <suffix>] <files>\n"
			 "See the complete manual in hypertex/doc.txt\n");
	 return 0;
 }

 IndReuse=0;IndTex=1;verbose=0;//IndIndex=0;
 for(i=1;i<narg;i++){
	 if(CompStr(varg[i],"-reuse"))IndReuse=1;
	 else if(CompStr(varg[i],"-notex"))IndTex=0;
	 else if(CompStr(varg[i],"-verbose"))verbose=1;
	 else if(CompStr(varg[i],"-suffix")){suff=CopyStr(varg[++i]);}
	 else break;
 }

 f=fopen(".htxrc","rb");
 if(f!=NULL)
	 rc=FileToStr(f);
 else{
	 if(verbose)printf("No .htxrc file in current directory, trying $HOME/.htxrc\n");
	 char*home=getenv("HOME");
	 char*htxrcname=new char[strlen(home)+8];sprintf(htxrcname,"%s/.htxrc",home);
	 f=fopen(htxrcname,"rb");
	 if(f!=NULL){
		 rc=FileToStr(f);
	 }else{
		 rc=new char[1];rc[0]=0;
		 if(verbose)printf("No .htxrc file to include.\n");
	 }
 }
 if(f!=NULL)fclose(f);

 f=fopen(HTMLHEAD,"rb");
 if(f!=NULL){
	 htmHead=FileToStr(f);
 }else{
	 f=fopen("htmlhead","rb");
	 if(f!=NULL){
		 htmHead=FileToStr(f);
	 }else{
		 htmHead=CopyStr(stdhtmhead);
		 if(verbose)printf("No %s file, using default.\n",HTMLHEAD);
	 }
 }
 if(f!=NULL)fclose(f);

 f=fopen(HTMLFOOT,"rb");
 if(f!=NULL)
	 htmFoot=FileToStr(f);
 else{
	 f=fopen("htmlfoot","rb");
	 if(f!=NULL){
		 htmFoot=FileToStr(f);
	 }else{
		 htmFoot=CopyStr(stdhtmfoot);
		 if(verbose)printf("No %s file, using default.\n",HTMLFOOT);
	 }
 }
 if(f!=NULL)fclose(f);

 f=fopen("texhead","rb");
 if(f!=NULL)
	 texHead=FileToStr(f);
 else{
	 texHead=CopyStr(stdtexhead);
	 if(verbose)printf("No texhead file, using default.\n");
 }
 if(f!=NULL)fclose(f);

 f=fopen("texfoot","rb");
 if(f!=NULL)
	 texFoot=FileToStr(f);
 else{
	 texFoot=CopyStr(stdtexfoot);
	 if(verbose)printf("No texfoot file, using default.\n");
}
 if(f!=NULL)fclose(f);


char*pathstr;long pathpos;char *s;

 long filenumber;
 for(filenumber=i;filenumber<narg;filenumber++){
	 printf("\nProcessing file %s\n",varg[filenumber]);
 f=fopen(varg[filenumber],"rb");
 pathstr=CopyStr(varg[filenumber]);pathpos=ExtraisPath(pathstr);
 if(pathpos>-1){printf("File does not lie in the current directory, ignored.\n");continue;
//	 pathstr[pathpos]=0;
//	 chdir(pathstr);//NOT SUPPORTED ANYMORE
 }
 if(f==NULL){
	 printf("File not found.\n");
	 return 0;
 }
	 nom=pathstr;
	 for(i=strlen(pathstr);i>=0&&pathstr[i]!='.';i--);
	 if(i>=0)pathstr[i]=0;
 s=FileToStr(f);
 fclose(f);

 compteur=0;nCommandes=0;nTableList=0;nfiles=0;

 /*  if(IndReuse)
 		 texfile=fopen(texfnom,"rb");
	 	 else texfile=fopen(texfnom,"wb");
		 fseek(texfile,0,0);*/

/* char *index;long posindex;
 if(IndIndex){
 	 f=fopen(INDEX,"rb");
 	 if(f!=NULL)
 		 index=FileToStr(f);
 	 else{
 		 index=CopyStr(stdindex);
 		 if(verbose)printf("No %s file, using default.\n",INDEX);
 	 }
 	 fclose(f);
 	 posindex=FindNext(index,"\\indexhere");
 	 if(posindex==-1)IndIndex=0;else IndIndex*=1;
 	 indexfnom=new char [strlen(nom)+15];
 	 sprintf(indexfnom,"%sindex%s",nom,suff);
	 index[posindex]=0;
	 indexfile=fopen(indexfnom,"wb");
	 fseek(indexfile,0,0);
	 EcrisIndex(index);
 }*/

 if(verbose)printf("\n");

 ScanString(rc,0,0);if(verbose)printf("\n");
 ScanNewFile(s,0);if(verbose)printf("\n");
 long numero;for(numero=0;numero<nfiles;numero++){
	 if(!strlen(FilesList[numero]->name)){
		 delete[]FilesList[numero]->name;
		 FilesList[numero]->name=new char[strlen(nom)+15];
		 if(numero)sprintf(FilesList[numero]->name,"%s%li",nom,numero);
		 else sprintf(FilesList[numero]->name,nom);
	 }
 	 if(verbose)printf("File %li named %s entitled %s parent %li prev %li next %li meta %s\n",numero,FilesList[numero]->name,FilesList[numero]->title,FilesList[numero]->parentfnum,FilesList[numero]->prevfnum,FilesList[numero]->nextfnum,FilesList[numero]->meta);
 }
 if(verbose)printf("\n");

 table=new char[1];table[0]=0;
 GenereTable();
 if(verbose)printf("Table:\n%s\n\n",table);

/* if(IndTex){
	 ProceedTeX(htmHead,InsStr(nom,strlen(nom),"head"));
	 ProceedTeX(s,CopyStr(nom));
	 ProceedTeX(htmFoot,InsStr(nom,strlen(nom),"foot"));
	 printf("\n");
 }*/

 InitTeX(FilesList[0]->name);
 TraiteNewFile(s);
 FinishTeX(FilesList[0]->name);

 /*  if(IndIndex){
 		 GenereIndex();
 		 EcrisIndex(index+posindex+11);
 		 fclose(indexfile);
 		 InsereIndexLiens();
	 	 }*/

 //  fclose(texfile);
 delete[] s;delete[]Commandes;delete[]FilesList;
 
 }
 
 delete[]htmHead;delete[]htmFoot;delete[]texHead;delete[]texFoot;delete[]rc;delete[]table;
 printf("\n");
 return 0;
}
