\title{Sample hypertex file}

(To compile properly, you must have a standard <TT>.htxrc</TT> file in
your home directory.)

\table

\section{LaTeX formulas}

Here is a simple equality: $1+1=2$.

Here is a much more complex formula: 
$$
\left(\sqrt{2}\right)^2=2
$$
and a very complicated proof:
\begin{eqnarray*}
0 & \leq & (a-b)^2
\\
0 & \leq & a^2-2ab+b^2
\\
ab & \leq & \frac{a^2+b^2}{2}
\end{eqnarray*}


Here is a complete \tex{\LaTeX} block: \tex{
	\textbf{Pythagoras'theorem} states that:
	$$
	\forall p,q \in \mathrm{\mathbf{N}},
	\left( \frac{p}{q}\right)^2 \neq 2
	$$
}

\section{Other commands}

Pointer to a \page{silly subpage}{
	\title{Subpage!}
	This is empty. You have been fooled.
}

You can invoke shell commande like this: Today is \shell{date}.

\newpage

\title{Who was Pythagoras?}

According to <a
href="http://en.wikipedia.org/wiki/Pythagoras">Wikipedia</a>,
Pythagoras of Samos was an Ionian Greek mathematician and founder of the
religious movement called Pythagoreanism.


The \toprev{previous page}, which was called \makeprevtitle, was no more
interesting than this one, was it?

